<template>
  <div class="uc-menu-container menu-drawer-border">
    <div class="uc-menu-grid">
      <nuxt-link
        v-for="item in tabsForDisplay"
        :key="item.label"
        :to="item.to"
        class="uc-menu-tile ol-bg-light"
        :title="$t(item.label)"
        @click="$emit('onClickSamePage')"
        :id="ID.SIDE_BAR_MENU[item.label]"
      >
        <div class="uc-menu-tile__content pointer-events-none">
          <div class="uc-menu-tile__icon-container">
            <SvgIcon :svg-name="item.icon" class="w-5 h-5" />
          </div>
          <span class="uc-menu-tile__label text-ellipsis">
            {{ $t(item.label) }}
          </span>
        </div>
        <MessagesMessageCount
          v-if="unreadInfo.TotalCount && item.label === 'messages'"
          :count="unreadInfo.TotalCount"
          :is-unread="true"
          class="!ml-0 absolute top-2 right-2"
          is-redirect
        ></MessagesMessageCount>
      </nuxt-link>
    </div>
  </div>
</template>

<script setup lang="ts">
import { store } from "~~/store";
const isAuth = computed(() => store.state.auth);
const route = useRoute();
const { isReferralV2Enabled } = useHeaderComponent();
const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
const { isShowPromotion } = useMenu();
const { fetchMessages, unreadInfo } = useMessage();
const isMobile = !useIsDesktop();
const tabsForDisplay = computed(() => {
  let tabs = [
    { to: `?uc=/wallet`, label: "wallet", icon: "icon-wallet", display: true },
    {
      to: `?uc=/account`,
      label: "account",
      icon: "icon-account",
      display: true,
    },
    {
      to: `?uc=/transaction-history`,
      label: "statement",
      icon: "icon-transaction",
      display: true,
    },
    {
      to: `?uc=/bet-history`,
      label: "bet_history",
      icon: "icon-bethistory",
      display: true,
    },
    {
      to: isMobile ? "/transaction-history/my-promotion" : `?uc=/my-promotion`,
      label: "promotion",
      icon: "icon-promotion",
      display: isShowPromotion.value,
    },
    {
      to: `?uc=/referral-v2`,
      label: "referral",
      icon: "icon-referral",
      display: isReferralV2Enabled.value && isShowReferralPage.value,
    },
    {
      to: `?uc=/messages`,
      label: "messages",
      icon: "message",
      display: true,
    },
  ];
  if (isMobile) {
    tabs = tabs.map((tab) => {
      tab.to = tab.to.replace("?uc=", "");
      return tab;
    });
  }
  if (!isAuth.value) return tabs;
  return tabs.filter((tab) => tab.display);
});

onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
</script>

<style scoped>
.uc-menu-container {
  display: flex;
  padding: 16px;
  flex-direction: column;
  align-items: flex-start;
  gap: 24px;
  align-self: stretch;
}

.uc-menu-grid {
  display: flex;
  justify-content: flex-start;
  align-items: center;
  align-content: center;
  gap: 8px;
  align-self: stretch;
  flex-wrap: wrap;
}

.uc-menu-tile {
  display: flex;
  width: calc(33.33% - 6px);
  aspect-ratio: 1;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  position: relative;
  border-radius: 8px;

  --bg-base-color: var(--background5);
  --bg-opacity: 0;
}

.uc-menu-tile__content {
  display: flex;
  padding: 8px 8px 0px 8px;
  flex-direction: column;
  align-items: center;
  flex: 1 0 0;
  align-self: stretch;
  border-radius: 8px;
  opacity: 0.5;
  transition: opacity 350ms ease;
  width: 100%;
  aspect-ratio: 1;
  overflow: hidden;
}
.uc-menu-tile:hover .uc-menu-tile__content,
.uc-menu-tile:focus .uc-menu-tile__content {
  opacity: 1;
}
.uc-menu-tile__icon-container {
  display: flex;
  width: 48px;
  height: 48px;
  justify-content: center;
  align-items: center;
  gap: 8px;
}

.uc-menu-tile__icon-container svg {
  width: 24px;
  height: 24px;
  flex-shrink: 0;
  fill: var(--text5);
}
.uc-menu-tile__label {
  /* display: flex;
  flex-direction: column;
  justify-content: center;
  align-self: stretch; */
  height: 32px;
  color: var(--text5, #fff);
  text-align: center;
  font-size: 12px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
  text-transform: uppercase;
}
</style>
